# IBDIAGNET 2.7.0

&copy; Copyright 2021, Mellanox Technologies, Inc. All Rights Reserved.

Juny 2021

Packages:

| Package     | Version |
| ----------- | ------- |
| MOFED       | 5.4.x   |
| UFM         | 6.7.x   |

## Main features
- NDR support
- Fat Tree topology validation tool

### PHY plugin
- New NDR registers
- New 7nm layouts
- Support hybrid SMP/GMP transport for registers

## Changes in command line parameters

### ibdiagnet

| Parameter name  | Status     | Description                                                     |
| :-------------- | ---------- | --------------------------------------------------------------- |
| `--ft`          | New        | Enabling Fat Tree Topology Validation (default - disabled)      |
| `--aguid`       | New        | Activate collection information about AGUIDs                    |
| `--enable_spst` | Removed    | SPST mode is enabled by default. Option was deprecated in 2.6.1 |

## Bug fixes

## Changes
- Virtualization stage redesigned to asynchronous mode
- AGUID stage disabled by default. Should be used cmd line parameter '--aguid' for activate it
- db_csv will contain information about connected ports only



# IBDIAGNET 2.6.2

&copy; Copyright 2021, Mellanox Technologies, Inc. All Rights Reserved.

March 2021

Packages:

| Package     | Version |
| ----------- | ------- |
| MOFED       | 5.3.x   |

## Main features
- Experimental NDR support

### PHY plugin
- Dump of MPCNT register is aligned to latest PRM

## Changes in command line parameters

### ibdiagnet

| Parameter name  | Status     | Description                                                                                      |
| :-------------- | ---------- | ------------------------------------------------------------------------------------------------ |
| `--ls`          | Changed    | "EDR20" is removed from the list of expected speeds                                              |
| `-u|--fat_tree` | Deprecated | Indicates that UpDown credit loop checking should be done against automatically determined roots |

### ibtopodiff

| Parameter name     | Status | Description                                                                   |
| :----------------- | ------ | ----------------------------------------------------------------------------- |
| `-n|--smart_names` | New    | Search switch node by description if node wasn't found by name (experimental) |

## Bug fixes

- Fixed: ibdiagnet uses wrong SHARP version (v1 - LLT, v2 - SAT) in job fetching
- Fixed: ibdmchk reports wrong size of multicast group, is SHARP is enabled
- Fixed: ibdiagnet reports congestion control counters for nodes with disabled congestion control 

## Changes

- phy_effective_errors and phy_symbol_errors in ibdiagnet2.net_dump_ext are reported from registers instead of PM counters
- Only 3 counters will be reported as error: SyncHeaderErrorCounter, UnknownBlockCounter, port_fec_uncorrectable_block_counter (only if PLR is disabled)
- ibdiagnet reports timestamp for input and output files
- PPCNT ZL_FEC_COUNTERS (DiagnosticData page 244) is removed from PHY plugin
- PHY plugiin: "Not supported" warnings are suppressed in log file, only total amount of warnings is reported. List of the warnings can be found in db_csv file
- Switch GUID and "node description" is added to "Aggregation Node" information in ibdiagnet2.sharp and ibdiagnet2.sharp_an_info


# IBDIAGNET 2.6.1

&copy; Copyright 2021, Mellanox Technologies, Inc. All Rights Reserved.

January 2021

Packages:

| Package     | Version |
| ----------- | ------- |
| UFM         | 6.6.x   |
| MOFED       | 5.2.x   |

MOFED 5.2.x also includes changes introduced by IBDIAGNET 2.5.0 .

## Main features

### ibdiagnet

- Adaptive Routing validation
- Performance improvement of routing checking
- New counters and diagnostic information:
  - SHARP: "SAT" ("Streaming Aggregation") counters
  - PHY: Max PLR per second field in PPCNT
  - PHY: SLLM register
  - PHY: New SymbolBER thresholds
  - Adaptive Routing: PortARTrails counter
- Support for SHARP security (AMKEY)
- Support for Congestion Control security (CCKEY)
- Support for Vendor Specific security (VSKEY)
- Reporting port counter differences when used `--pm_pause_time` (`PM_DELTA` section in db_csv)
- Dragonfly+ Topology Validation (`--dfp`, `--dfp_opt [<max_cas>]` ).


### ibtopodif

- Support for "stable" names of RDMA devices based on PCI/slot/function location

## Changes in command line parameters

### ibdiagnet

| Parameter name                  | Status                                | Description                                                                                             |
| :------------------------------ | ------------------------------------- | ------------------------------------------------------------------------------------------------------- |
| `--smp_window`                  | Upper limit and default are changed   | Max: 256;  default: 16                                                                                  |
| `--gmp_window`                  | Upper limit and default are changed   | Max: 16384; default: 256                                                                                |
| `--am_key`                      | New                                   | Specifies default AMKEY for the fabric                                                                  |
| `--am_key_file`                 | New                                   | Specifies the path to file (AMKEY per GUID)                                                             |
| `--smdb`                        | New                                   | Specifies the path to OpenSM SMDB file (required for Adaptive Routing & Dragonfly+ Topology validation) |
| `--ber_threshold_table`         | New                                   | Specifies the path to BER thresholds table file (BER per FEC)                                           |
| `--create_ber_threshold_table`  | New                                   | Creates template file of BER threshold table                                                            |
| `--enable_spst`                 | Deprecated                            | SPST mode is enabled by default                                                                         |
| `--dfp`                         | New                                   | Enabling DFP Topology Validation (default - disabled)                                                   |
| `--dfp_opt`                     | New                                   | Specifies comma separated DFP Topology Validation options                                               |
| `--cc_key`                      | New                                   | Specifies default Congestion Control key for the fabric                                                 |
| `--cc_key_file`                 | New                                   | Specifies the path to file (Congestion Control key per GUID)                                            |
| `--vs_key`                      | New                                   | Specifies default Vendor Specific key for the fabric                                                    |
| `--vs_key_file`                 | New                                   | Specifies the path to file (Vendor Specific key per GUID)                                               |


#### --dfp_opt

| Parameter name                | Description                                                                                                                     |
| :---------------------------- | ------------------------------------------------------------------------------------------------------------------------------- |
| `<max_cas>`                   | Specifies max number of CAs for "Root" switch in Dragonfly+ island (default: 1). This parameter is mutual exclusive with --smdb |


### ibdmchk

| Parameter name                | Status                 | Description                                                      |
| :---------------------------- | ---------------------- | ---------------------------------------------------------------- |
| `--FAR`                       | New                    | Adds support for input FAR file                                  |



## Bug fixes

- Fixed: ibtopodiff doesn't recognize IB Routers
- Fixed: Reset flow for PHY/PCI counters

## Changes

- ibdiagnet reports version on screen and in log file
- ibnetdiscover dump file, created by ibdiagnet, includes Virtual Port info


# IBDIAGNET 2.6.0

&copy; Copyright 2020, Mellanox Technologies, Inc. All Rights Reserved.

December 2020

Packages:

| Package     | Version |
| ----------- | ------- |
| UFM         | 6.6.x   |
| MOFED       | 5.2.x   |

MOFED 5.2.x also includes changes introduced by IBDIAGNET 2.5.0 .

## Main features

### ibdiagnet

- Adaptive Routing validation
- Performance improvement of routing checking
- New counters and diagnostic information:
  - SHARP: "SAT" ("Streaming Aggregation") counters
  - PHY: Max PLR per second field in PPCNT
  - PHY: SLLM register
  - PHY: New SymbolBER thresholds
  - Adaptive Routing: PortARTrails counter
- Support for SHARP security (AMKEY)
- Reporting port counter differences when used `--pm_pause_time` (`PM_DELTA` section in db_csv)

### ibtopodif

- Support for "stable" names of RDMA devices based on PCI/slot/function location

## Changes in command line parameters

### ibdiagnet

| Parameter name                  | Status                                | Description                                                                         |
| :------------------------------ | ------------------------------------- | ----------------------------------------------------------------------------------- |
| `--smp_window`                  | Upper limit and default are changed   | Max: 256;  default: 16                                                              |
| `--gmp_window`                  | Upper limit and default are changed   | Max: 16384; default: 256                                                            |
| `--am_key`                      | New                                   | Specifies default AMKEY for the fabric                                              |
| `--am_key_file`                 | New                                   | Specifies the path to file (AMKEY per GUID)                                         |
| `--smdb`                        | New                                   | Specifies the path to OpenSM SMDB file (required for Adaptive Routing validation)   |
| `--ber_threshold_table`         | New                                   | Specifies the path to BER thresholds table file (BER per FEC)                       |
| `--create_ber_threshold_table`  | New                                   | Creates template file of BER threshold table                                        |
| `--enable_spst`                 | Deprecated                            | SPST mode is enabled by default                                                     |


### ibdmchk

| Parameter name                | Status                 | Description                                                      |
| :---------------------------- | ---------------------- | ---------------------------------------------------------------- |
| `--FAR`                       | New                    | Adds support for input FAR file                                  |



## Bug fixes

- Fixed: ibtopodiff doesn't recognize IB Routers
- Fixed: Reset flow for PHY/PCI counters

## Changes

- ibdiagnet reports version on screen and in log file
- ibnetdiscover dump file, created by ibdiagnet, includes Virtual Port info


# IBDIAGNET 2.5.0

&copy; Copyright 2020, Mellanox Technologies, Inc. All Rights Reserved.

September 2020

Packages:

| Package     | Version |
| ----------- | ------- |
| UFM         | 6.5.2   |

## Main features

- Rail Optimized Topology Validation (`--rail_validation`, `--rail_validation_opt [<regex>]` ). Checking links between compute nodes and leaf switches to provide rail optimized topology
- Customization SL for GMP MADs in ibdiagnet (`--sl`)



## Changes in command line parameters

### ibdiagnet

| Parameter name                | Status     | Description                                                           |
| :---------------------------- | ---------- | --------------------------------------------------------------------- |
| `--sl`                        | New        | Specifies the SL to be used (default=0)                               |
| `--rail_validation`           | New        | Enabling Rail Optimized Topology Validation (default - disabled)      |
| `--rail_validation_opt`       | New        | Specifies comma separated Rail Optimized Topology Validation options  |
| `--clear_congestion_counters` | New        | Dumping Congestion Counters and clearing them                         |
| `--fec_mode`                  | Deprecated | FEC_MODE section will be dump to "db_csv" by default                  |


#### --rail_validation_opt

| Parameter name                | Description                                                                                            |
| :---------------------------- | ------------------------------------------------------------------------------------------------------ |
| `<regex>`                     | Specifies regular expression to filter HCA nodes from reports. To be applied to HCAs node descriptions |


## Bug fixes

- Fixed: Correct print errors/warning status in stages
- Fixed: Critical error in case duplicate names with HCA/mlx patterns

## Changes

- Add output similar to the result of the "ibnetdiscovery"
- ibdiagnet: Disable output by default for AR/FDBS files in routing stage
- Move SHARP performance counters to db_csv
- Dump by default FEC_MODE section in db_csv
- Improve AR connectivity check 


# IBDIAGNET 2.4.1

&copy; Copyright 2020, Mellanox Technologies, Inc. All Rights Reserved.

September 2020

Packages:

| Package     | Version |
| ----------- | ------- |
| UFM         | 6.5.2   |

## Main features

- Rail Optimized Topology Validation (`--rail_validation`, `--rail_validation_opt [<regex>]` ). ibdianget will validate cabling between hosts and "leaf" switches in "Rail Optimized Topology".
  For multi-ports compute nodes, "Rail Optimisation" means: 'leaf' switch serves only HCAs belonging the same "rail" (HCA position in compute node)
- Now, ibdiagnet can use custom (non-zero) SL for sending GMP MADs (`--sl`)

## Changes in command line parameters

### ibdiagnet

| Parameter name                | Status     | Description                                                           |
| :---------------------------- | ---------- | --------------------------------------------------------------------- |
| `--sl`                        | New        | specifies SL for sending GMP MADs (default: 0)                        |
| `--rail_validation`           | New        | enables Rail Optimized Topology Validation (default: disabled)        |
| `--rail_validation_opt`       | New        | specifies comma separated Rail Optimized Topology Validation options  |
| `--clear_congestion_counters` | New        | dumps Congestion Counters and clears them                             |
| `--fec_mode`                  | Deprecated | "FEC_MODE" section will be dump to "db_csv" by default                |

#### --rail_validation_opt

This option allows to provide additional parameters to Rail Optimized Topology Validation. Now, only "regex" option is supported.
"regex" is an expression in "POSIX Extended Regular Expression" format. Only nodes with node description matching this regex are subject for Rail Optimized
Topology Validation.

Example:

``` bash
$ ibdiagnet --rail_validation --rail_validation_opt regex='dgx*'
```

## Bug fixes

- Fixed: ibdiagnet fails to discovery IB fabric with duplicated node descriptions matching patterns: "HCA-N", or "mxl-N". Case number: 00870180

## Changes

- ibdignet will output a human readable topology file in format similar to "ibnetdiscovery".
  This file will include virtual ports and split cables information
- ibdiagnet will not output by default AR/FDBS files in "routing" stage
- SHARP performance counters are moved from separate file to db_csv (`SHARP_PM_COUNTERS` section)
- ibdiagnet will dump FEC_MODE section in db_csv by default. `--fec_mode` parameter is deprecated
- Performance of AR (Adaptive Routing) connectivity check is improved


# IBDIAGNET 2.4.0

July 2020

&copy; Copyright 2020, Mellanox Technologies, Inc. All Rights Reserved.

Packages:

| Package     | Version |
| ----------- | ------- |
| MLNX_OFED   | 5.1     |
| UFM         | 6.5.0   |

## Main features

- Flexible output control options (`--enable_output` , `--disable_output`, `--path`)
- Discovery only mode (`--discovery_only`)
- Support for MLNX Congestion Control counters

## Performance improvements

The performance of following steps in ibdiagnet has been improved:
- Routing validation
- Network discovery
- Virtualization stage
- Dump creation

## Changes in command line parameters

### ibdiagnet

| Parameter name     | Status                 | Description                                                  |
| :----------------- | ---------------------- | ------------------------------------------------------------ |
| `--enable_output`  | New                    | Enable creation of specific dump file                        |
| `--disable_output` | New                    | Disable specific dump file                                   |
| `--path`           | New                    | Set custom path for specific dump file                       |
| `--discovery_only` | New                    | Discover IB fabric, save topology information into "db_csv" file and exit |
| `--smp_window`     | Upper limit is changed | New max is 128                                               |
| `--gmp_window`     | Upper limit is changed | New max is 8192                                              |

### ibtopodiff

| Parameter name | Status | Description             |
| -------------- | ------ | ----------------------- |
| `--ibnl_dir`   | New    | Set path for IBNL files |


* * *

## Bug fixes

- Fixed: ibdiagnet skips PCIe counters for some HCAs, if more than one HCA is installed in the host
- Fixed: ibdiagnet reports wrong value for SLRG 16nm register
- Fixed: ibdiagnet reports wrong value in SMP access register
- Fixed: ibdiagnet reports wrong number of "Aggregation Nodes" in "Fabric Summary" table

## Changes:

- "Fabric Summary" is enabled by default
- Dates and versions in "nodes_info" file are printed in human-readable format
- Dump files include ibdiagnet version and command line parameters
- Added split mode to IBNL for "InfiniBand Smart Director Switches" (CS8500)

